;;; -*- Mode: LISP; Syntax: ANSI-Common-Lisp; Base: 10 -*-
;; See the file LICENCE for licence information.

(defpackage #:cl-store
  (:use #:cl) 
  (:export #:backend
           #:name
           #:magic-number
           #:stream-type
           #:restorer-funs
           #:restorers
           #:find-backend
           #:defbackend
           #:with-backend
           #:fix-circularities
           #:*default-backend*
           #:*cl-store-backend*
           #:*current-backend*
           #:*store-class-slots*
           #:*nuke-existing-classes*
           #:*store-class-superclasses*
           #:store-error
           #:restore-error
           #:store
           #:restore
           #:backend-store
           #:check-stream-element-type
           #:store-backend-code
           #:store-object
           #:backend-store-object
           #:get-class-details
           #:get-array-values
           #:restore
           #:backend-restore
           #:check-magic-number
           #:get-next-reader
           #:restore-object
           #:backend-restore-object
           #:cl-store
           #:defstore-cl-store
           #:defrestore-cl-store
           #:register-code
           #:output-type-code
           #:xml)
  #+sbcl (:import-from #:sb-mop
                       #:slot-definition-name
                       #:slot-value-using-class
                       #:slot-boundp-using-class
                       #:slot-definition-allocation
                       #:compute-slots
                       #:slot-definition-initform
                       #:slot-definition-initargs
                       #:slot-definition-name
                       #:slot-definition-readers
                       #:slot-definition-type
                       #:slot-definition-writers
                       #:class-direct-default-initargs
                       #:class-direct-slots
                       #:class-direct-superclasses
                       #:class-slots
                       #:ensure-class)
  
  #+cmu  (:import-from #:pcl
                       #:slot-definition-name
                       #:slot-value-using-class
                       #:slot-boundp-using-class
                       #:slot-definition-allocation
                       #:compute-slots
                       #:slot-definition-initform
                       #:slot-definition-initargs
                       #:slot-definition-name
                       #:slot-definition-readers
                       #:slot-definition-type
                       #:slot-definition-writers
                       #:class-direct-default-initargs
                       #:class-direct-slots
                       #:class-direct-superclasses
                       #:class-slots
                       #:ensure-class)
  
  #+cmu (:shadowing-import-from #:pcl
                                #:class-name
                                #:find-class
                                #:standard-class
                                #:class-of)
  
  #+openmcl (:import-from #:openmcl-mop
                          #:slot-definition-name
                          #:slot-value-using-class
                          #:slot-boundp-using-class
                          #:slot-definition-allocation
                          #:compute-slots
                          #:slot-definition-initform
                          #:slot-definition-initargs
                          #:slot-definition-name
                          #:slot-definition-readers
                          #:slot-definition-type
                          #:slot-definition-writers
                          #:class-direct-default-initargs
                          #:class-direct-slots
                          #:class-direct-superclasses
                          #:class-slots
                          #:ensure-class)
  
  #+clisp (:import-from #:clos
                        #:slot-value
                        #:std-compute-slots
                        #:slot-boundp
                        #:class-name
                        #:class-direct-default-initargs
                        #:class-direct-slots
                        #:class-slots
                        #:ensure-class)
  
  #+lispworks  (:import-from #:clos
                             #:slot-definition-name
                             #:slot-value-using-class
                             #:slot-boundp-using-class
                             #:slot-definition-allocation
                             #:compute-slots
                             #:slot-definition-initform
                             #:slot-definition-initargs
                             #:slot-definition-name
                             #:slot-definition-readers
                             #:slot-definition-type
                             #:slot-definition-writers
                             #:class-direct-default-initargs
                             #:class-direct-slots
                             #:class-slots
                             #:class-direct-superclasses
                             #:ensure-class))



;; package used to unclutter cl-store by holding all %referrer symbols.
(defpackage #:cl-store-referrers)

;; EOF